﻿using System;
using System.IO;

namespace IntelliSite.CommonUtil
{
	public enum ConnectionStatus : byte
	{
		Success         = 1,
		Rejected        = 2,
		Timeout         = 3,
		VersionMismatch = 4,
		UnknownFailure  = 255
	}

	[Message]
	public class ConnectStatusMessage : MessageBase
	{
		public const short MessageType = 2;

		public ConnectionStatus Status { get; private set; }

		public ConnectStatusMessage( ConnectionStatus status )
		{
			Type = MessageType;
			Status = status;

			Data = new byte[1];
			Data[0] = (byte)status;
		}

		public ConnectStatusMessage( MessageBase message )
			: base( message )
		{
			Status = (ConnectionStatus)Data[0];
		}

		public override string ToString()
		{
			return "ConnectionStatus: " + Status;
		}
	}
}
