﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Sockets;
using System.Text;

namespace IntelliSite.CommonUtil
{
	public class ErrorArgs : EventArgs
	{
		public string       Text        { get; private set; }
		public Exception    Exception   { get; private set; }
		public SocketError? SocketError { get; private set; }
		public object       Source      { get; private set; }

		public ErrorArgs( object source, string text, Exception e = null )
			: base()
		{
			Source      = source;
			Text        = text;
			Exception   = e;
			SocketError = null;

			if( e is SocketException )
				SocketError = ( (SocketException)e ).SocketErrorCode;
		}

		public ErrorArgs( object source, string text, SocketError se )
			: base()
		{
			Source      = source;
			Text        = text;
			Exception   = null;
			SocketError = se;
		}

		public override string ToString()
		{
			if( Exception != null )
				return Text + Exception.ToString();
			else if( SocketError != null && SocketError != System.Net.Sockets.SocketError.Success )
				return Text + SocketError.ToString();
			else
				return Text;
		}
	}
}
