﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace IntelliSite.CommonUtil.Extensions
{
	public static class ArrayExtensions
	{
		public static string ToUpperHexString( this byte[] bytes )
		{
			// Modified code from: http://stackoverflow.com/a/3974535

			if( bytes == null )
				throw new ArgumentNullException( "bytes" );

			byte nibble;
			char[] chars = new char[bytes.Length * 2];

			const byte asciiLetterOffset = 0x37;
			const byte asciiDigitOffset = 0x30;

			for( int bx = 0, cx = 0; bx < bytes.Length; ++bx, ++cx )
			{
				nibble = ( (byte)( bytes[bx] >> 4 ) );
				chars[cx] = (char)( nibble + ( nibble > 9 ? asciiLetterOffset : asciiDigitOffset ) );

				nibble = ( (byte)( bytes[bx] & 0x0F ) );
				chars[++cx] = (char)( nibble + ( nibble > 9 ? asciiLetterOffset : asciiDigitOffset ) );
			}

			return new string( chars );
		}

		public static string ToLowerHexString( this byte[] bytes )
		{
			// Modified code from: http://stackoverflow.com/a/3974535

			if( bytes == null )
				throw new ArgumentNullException( "bytes" );

			byte nibble;
			char[] chars = new char[bytes.Length * 2];

			const byte asciiLetterOffset = 0x57;
			const byte asciiDigitOffset = 0x30;

			for( int bx = 0, cx = 0; bx < bytes.Length; ++bx, ++cx )
			{
				nibble = ( (byte)( bytes[bx] >> 4 ) );
				chars[cx] = (char)( nibble + ( nibble > 9 ? asciiLetterOffset : asciiDigitOffset ) );

				nibble = ( (byte)( bytes[bx] & 0x0F ) );
				chars[++cx] = (char)( nibble + ( nibble > 9 ? asciiLetterOffset : asciiDigitOffset ) );
			}

			return new string( chars );
		}
	}
}
