﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace IntelliSite.CommonUtil.Extensions
{
	public static class EventExtensions
	{
		public static EventHandler<TEventArgs> FireEvent<TEventArgs>( this EventHandler<TEventArgs> handler, object sender, TEventArgs e )
			where TEventArgs : EventArgs
		{
			if( handler != null )
				handler( sender, e );

			return handler;
		}

		public static EventHandler FireEvent( this EventHandler handler, object sender, EventArgs e )
		{
			if( handler != null )
				handler( sender, e );

			return handler;
		}

		public static TEventArgs FireWithHandler<TEventArgs>( this TEventArgs e, EventHandler<TEventArgs> handler, object sender )
			where TEventArgs : EventArgs
		{
			if( handler != null )
				handler( sender, e );

			return e;
		}

		public static EventArgs FireWithHandler( this EventArgs e, EventHandler handler, object sender )
		{
			if( handler != null )
				handler( sender, e );

			return e;
		}
	}
}
