﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace IntelliSite.CommonUtil
{
	[Flags]
	public enum ResolveProductAssemblyOptions
	{
		// versioning flag values
		AllowLaterVersionForProductAssemblies = 1 << 0,
		AllowLaterVersionForOtherAssemblies = 1 << 1,
		LoadHighestVersionForProductAssemblies = 1 << 2,

		// check location flag values
		CheckAppDomainLoaded = 1 << 8,
		CheckInstallPath = 1 << 9,
		CheckGlobalAssemblyCache = 1 << 10,
		CheckInstalledComponents = 1 << 11,
		CheckInstalledDrivers = 1 << 12,
		CheckInstalledDatabaseProviders = 1 << 13,

		// flag combination values
		None = 0,

		AllowLaterVersionForAny = ( AllowLaterVersionForProductAssemblies | AllowLaterVersionForOtherAssemblies ),

		CheckAllInstalledItems = ( CheckInstalledComponents | CheckInstalledDrivers | CheckInstalledDatabaseProviders ),
		CheckAllLocations = ( CheckAppDomainLoaded | CheckInstallPath | CheckGlobalAssemblyCache | CheckAllInstalledItems ),

		Default = ( CheckAllLocations | AllowLaterVersionForProductAssemblies | LoadHighestVersionForProductAssemblies ),
	}
}
