﻿using System;

namespace IntelliSite.CommonUtil
{
	public enum MessageDestination
	{
		Stream     = 0,
		AllClients = 1,
		AllDrivers = 2,
		All        = 3,
		Engine     = 4
	}

	public class SendMessageArgs : EventArgs
	{
		public MessageStream Stream { get; private set; }
		public MessageBase Message { get; private set; }
		public MessageDestination Destination { get; private set; }
		public UInt32 DestinationID { get; private set; }

		public SendMessageArgs( MessageDestination destination, MessageBase message, UInt32 destinationID=0 )
			: base()
		{
			Destination = destination;
			DestinationID = destinationID;
			Stream = null;
			Message = message;
		}

		public SendMessageArgs( MessageStream stream, MessageBase message )
			: base()
		{
			Destination = MessageDestination.Stream;
			DestinationID = 0;
			Stream = stream;
			Message = message;
		}

		public override string ToString()
		{
			switch( Destination )
			{
				case MessageDestination.Stream:
					return "(" + Stream.Name + ") " + Message;
				default:
					return "(" + Destination + ") " + Message + " ID: " + DestinationID;
			}
		}
	}

}
