﻿using System;
using System.Collections.Generic;
using System.Net.Sockets;
using System.Text;
using System.Threading;

namespace IntelliSite.CommonUtil
{
	public class SocketState : DisposableBase
	{
		public MessageSocket      Parent { get; private set; }
		public Socket             Socket { get; private set; }
		public object             Data { get; private set; }
		public byte               Type { get; set; }
		public bool               IsBuffer1 { get; set; }
		public byte []            FromRemoteBuffer1 { get; private set; }
		public byte []            FromRemoteBuffer2 { get; private set; }
		public byte []            FromRemotePartial { get; private set; }
		public int                FromRemotePartLen { get; private set; }
		public MessageBase        FromRemoteMessage { get; set; }
		public byte []            ToRemoteBuffer { get; private set; }
		public Queue<MessageBase> ToRemoteQueue { get; private set;  }
		public AutoResetEvent     ToRemoteEvent { get; private set; }
		public bool               IsSendActive { get; set; }
		public string             LastError { get; set; }

		public SocketState( MessageSocket parent, Socket socket )
		{
			Parent              = parent;
			Socket              = socket;
			Data				= null;
			Type				= 0;
			IsBuffer1			= true;
			FromRemoteBuffer1	= new byte[16384];
			FromRemoteBuffer2	= new byte[16384];
			FromRemotePartial	= new byte[MessageBase.MessageBlockSize];
			FromRemotePartLen	= 0;
			FromRemoteMessage	= null;
			ToRemoteBuffer		= new byte[MessageBase.MessageBlockSize];
			ToRemoteQueue		= new Queue<MessageBase>();
			ToRemoteEvent		= new AutoResetEvent( false );
			IsSendActive		= false;
		}

		protected override void Dispose( bool disposing )
		{
		}
	}
}
