# PowerShell script
#
# Add to project's Pre-build command line with:
# "$(SystemRoot)\System32\WindowsPowerShell\v1.0\powershell.exe" -NoLogo -NonInteractive -Command .'$(SolutionDir)Scripts\build-pre.ps1' -SolutionDir:'$(SolutionDir)' -ProjectDir:'$(ProjectDir)' -ConfigurationName:'$(ConfigurationName)' -TargetDir:'$(TargetDir)' -TargetFileName:'$(TargetFileName)' -TargetName:'$(TargetName)'
#
param($SolutionDir, $ProjectDir, $ConfigurationName, $TargetDir, $TargetFileName, $TargetName)

write-host "Script started: build-pre.ps1"

$SolutionBinDir     = join-path -path $SolutionDir "bin\"
$SolutionScriptsDir = join-path -path $SolutionDir "Scripts\"

if (-not (test-path -pathType container $SolutionBinDir))
{
	new-item -path $SolutionBinDir -type directory
}

if (test-path -pathType container $SolutionScriptsDir)
{
	robocopy /NJH /NJS /V /NP "$SolutionScriptsDir" "$SolutionBinDir" "do.bat"
}
