﻿using System;
using System.Collections;
using System.Collections.Generic;

namespace IntelliSite.DigitalWatchdog.Driver
{

    public class CameraObject
    {
        public Addparam[] addParams { get; set; }
        public bool audioEnabled { get; set; }
        public string backupType { get; set; }
        public bool controlEnabled { get; set; }
        public string dewarpingParams { get; set; }
        public string failoverPriority { get; set; }
        public string groupId { get; set; }
        public string groupName { get; set; }
        public string id { get; set; }
        public bool licenseUsed { get; set; }
        public string mac { get; set; }
        public bool manuallyAdded { get; set; }
        public int maxArchiveDays { get; set; }
        public int minArchiveDays { get; set; }
        public string model { get; set; }
        public string motionMask { get; set; }
        public string motionType { get; set; }
        public string name { get; set; }
        public string parentId { get; set; }
        public string physicalId { get; set; }
        public string preferedServerId { get; set; }
        public bool scheduleEnabled { get; set; }
        public object[] scheduleTasks { get; set; }
        public string secondaryStreamQuality { get; set; }
        public string status { get; set; }
        public string statusFlags { get; set; }
        public string typeId { get; set; }
        public string url { get; set; }
        public string userDefinedGroupName { get; set; }
        public string vendor { get; set; }

        public bool IsValid { get { return this.mac != "00-00-00-00-00-00"; } } //this.status == "Online" && this.mac != "00-00-00-00-00-00"; } }
    }

    public class Addparam
    {
        public string name { get; set; }
        public string value { get; set; }
    }

    public class CameraObjects : ICollection<CameraObject>
    {

        public CameraObjects() { this.cameras = new List<CameraObject>(); }
        public bool IsReadOnly { get { return false; } }

        [Newtonsoft.Json.JsonPropertyAttribute("cameras")]
        public List<CameraObject> cameras { get; set; }

        public int Count { get { return this.cameras.Count; } }

        public void Add(CameraObject item) { this.cameras.Add(item); }
        public bool Remove(CameraObject item) { return this.cameras.Remove(item); }
        public void Clear() { this.cameras.Clear(); }

        public bool Contains(CameraObject item) { return this.cameras.Contains(item); }

        public void CopyTo(CameraObject[] array, int arrayIndex) { this.cameras.CopyTo(array, arrayIndex); }

        public IEnumerator<CameraObject> GetEnumerator() { return this.cameras.GetEnumerator(); }

        IEnumerator IEnumerable.GetEnumerator() { return this.cameras.GetEnumerator(); }

    }

}