﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IntelliSite.DigitalWatchdog.Driver
{
    public class CameraStatusObject
    {
        public string id { get; set; }
        public string status { get; set; }
    }

    public class CameraStatusObjects : ICollection<CameraStatusObject>
    {
        private string _error = "";

        public CameraStatusObjects() { camerastatuslist = new List<CameraStatusObject>(); }
        public bool IsReadOnly { get { return false; } }
        public string Error  { get { return _error; }
                               set { _error = value.Trim().Replace("ERROR:", ""); } }
        public bool HasError { get { return !String.IsNullOrWhiteSpace(Error); } }

        [Newtonsoft.Json.JsonPropertyAttribute("camerastatuslist")]
        public List<CameraStatusObject> camerastatuslist { get; set; }

        public int Count { get { return this.camerastatuslist.Count; } }

        public void Add(CameraStatusObject item) { this.camerastatuslist.Add(item); }
        public bool Remove(CameraStatusObject item) { return this.camerastatuslist.Remove(item); }
        public void Clear() { this.camerastatuslist.Clear(); }

        public bool Contains(CameraStatusObject item) { return this.camerastatuslist.Contains(item); }

        public void CopyTo(CameraStatusObject[] array, int arrayIndex) { this.camerastatuslist.CopyTo(array, arrayIndex); }

        public IEnumerator<CameraStatusObject> GetEnumerator() { return this.camerastatuslist.GetEnumerator(); }

        IEnumerator IEnumerable.GetEnumerator() { return this.camerastatuslist.GetEnumerator(); }
    }
}
