﻿using System;
using System.Collections;
using System.Collections.Generic;

namespace IntelliSite.DigitalWatchdog.Driver
{



    public class SettingsObject
    {
        public string name { get; set; }
        public string value { get; set; }
    }

    public class SettingsObjects : ICollection<SettingsObject>
    {
        private string _error = "";

        public SettingsObjects() { settingslist = new List<SettingsObject>(); }
        public bool IsReadOnly { get { return false; } }
        public string Error
        {
            get { return _error; }
            set { _error = value.Trim().Replace("ERROR:", ""); }
        }
        public bool HasError { get { return !String.IsNullOrWhiteSpace(Error); } }

        [Newtonsoft.Json.JsonPropertyAttribute("settingslist")]
        public List<SettingsObject> settingslist { get; set; }

        public int Count { get { return this.settingslist.Count; } }

        public void Add(SettingsObject item) { this.settingslist.Add(item); }
        public bool Remove(SettingsObject item) { return this.settingslist.Remove(item); }
        public void Clear() { this.settingslist.Clear(); }

        public bool Contains(SettingsObject item) { return this.settingslist.Contains(item); }

        public void CopyTo(SettingsObject[] array, int arrayIndex) { this.settingslist.CopyTo(array, arrayIndex); }

        public IEnumerator<SettingsObject> GetEnumerator() { return this.settingslist.GetEnumerator(); }

        IEnumerator IEnumerable.GetEnumerator() { return this.settingslist.GetEnumerator(); }
    }
}
