﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Text;
using System.Threading.Tasks;

namespace IntelliSite.VideoCommon
{
    public enum VideoAlarmType
    {
        SystemAlarm,
        Bookmark,
        Event,
        Alarm
    }
    public class VideoAlarm
    {
        public VideoAlarmType AlarmType { get; set; }
        public string Description { get; set; }
        public DateTime StartTime { get; set; }
        public DateTime EndTime { get; set; }
        public Rectangle Rect { get; set; }

        public string Start { get { return StartTime.ToString("MM/dd/yyyy HH:mm:ss"); } }
        public string End { get { return EndTime.ToString("MM/dd/yyyy HH:mm:ss"); } }

        public VideoAlarm(VideoAlarmType alarmType, string description, DateTime startTime, DateTime endTime)
        {
            AlarmType = alarmType;
            Description = description;
            StartTime = startTime;
            EndTime = endTime;
        }
    }
}
