﻿using System;
using System.Collections.Generic;

namespace IntelliSite.WinForms.VideoView
{
	public class GetAlarmsArgs : EventArgs
	{
		public DateTime StartTime { get; set; }
		public DateTime EndTime { get; set; }
		public bool SystemAlarms;
		public bool Bookmarks;
		public bool Events;
		public bool Alarms;

		public GetAlarmsArgs( DateTime startTime, DateTime endTime, bool systemAlarms, bool bookmarks, bool events, bool alarms )
		{
			StartTime    = startTime;
			EndTime      = endTime;
			SystemAlarms = systemAlarms;
			Bookmarks    = bookmarks;
			Events       = events;
			Alarms       = alarms;
		}

		public override string ToString()
		{
			string retVal = "GetAlarmsArgs: " + StartTime.ToShortTimeString() + " - " + EndTime.ToShortTimeString();
			if( SystemAlarms )	retVal += " SystemAlarms";
			if( Bookmarks )	retVal += " Bookmarks";
			if( Events )	retVal += " Events";
			if( Alarms )	retVal += " Alarms";

			return retVal;
		}
	}
}
